/* --------------------------------------------------------------
          ( 2.2).
       .

    http://www.imach.uran.ru/cbignum

    Copyright 1999-2024, ..,   PAH.
    All Rights Reserved.

         "public domain",
    ..   ,  
         
          .

        " "
     - ,   . 
           . 
          , ,
            
       .
-------------------------------------------------------------- */
#ifndef _CBNL_H
#define _CBNL_H

#include <assert.h>
#include <limits.h>

//================================================
//          .
//================================================

/*
    Visual C++ 6.0    32- .
*/
#ifdef  _MSC_VER
#if     _MSC_VER >= 1200
#ifdef  _M_IX86
#if 0
#define _CBNL_C     __fastcall
#endif
#endif//_M_IX86
#endif//_MSC_VER
#endif//_MSC_VER

/*
     .
*/
#ifndef _CBNL_C
#define _CBNL_C
#endif//_CBNL_C

//================================================
//       CBNC   .
//================================================

#ifndef CBNC
#define CBNC int
#endif//CBNC

//================================================
//       CBNL.
//================================================
/*
    CBNL_LONG_LONG   CBNL   long
*/

/*
    Visual C++  64-  (x64/Itanium).
*/
#ifdef  _MSC_VER
#ifdef  _WIN64
#define CBNL __int64
#define CBNL_MIN    _I64_MIN
#define CBNL_MAX    _I64_MAX
#define UCBNL_MAX   _UI64_MAX
#define CBNL_LONG_LONG
#include "Cbnl64.inl"
#endif//_WIN64
#endif//_MSC_VER

/*
       C++11.
*/
#ifndef CBNL
#ifdef  __cplusplus
#if     __cplusplus >= 201103L
#if LLONG_MAX != LONG_MAX
#define CBNL long long
#define CBNL_MIN    LLONG_MIN
#define CBNL_MAX    LLONG_MAX
#define UCBNL_MAX   ULLONG_MAX
#define CBNL_LONG_LONG
#include "Cbnl.inl"
#endif
#endif//__cplusplus
#endif//__cplusplus
#endif//CBNL

/*
     .
*/
#ifndef CBNL
#define CBNL long
#define CBNL_MIN    LONG_MIN
#define CBNL_MAX    LONG_MAX
#define UCBNL_MAX   ULONG_MAX
#include "Cbnl.inl"
#endif//CBNL

//================================================
//         
//        .
//================================================

/*
    Visual C++ 6.0    32- :
    _CBNL_CBNL     
    _CBNL_MUL       
*/
#ifdef  _MSC_VER
#if     _MSC_VER >= 1200
#ifdef  _M_IX86
#define _CBNL_CBNL  __int64
#define _CBNL_MUL
#endif//_M_IX86
#endif//_MSC_VER
#endif//_MSC_VER

/*
    Visual C++ 2005    32  64- :
    _CBNL_MI       Microsoft
    _CBNL_MUL       
*/
#ifdef  _MSC_VER
#if     _MSC_VER >= 1400
#ifdef  _M_IX86
#define _CBNL_MI    32
#endif//_M_IX86
#ifdef  _WIN64
#define _CBNL_MI    64
#define _CBNL_MUL
#endif//_WIN64
#endif//_MSC_VER
#endif//_MSC_VER

/*
    Visual C++ 2013  :
    _CBNL_CBI      /
*/
#ifdef  _MSC_VER
#if     _MSC_VER >= 1800
#define _CBNL_CBI
#endif//_MSC_VER
#endif//_MSC_VER

/*
    Visual C++ 2019  :
    _CBNL_DI         
    _CBNL_DIV      
*/
#ifdef  _MSC_VER
#if     _MSC_VER >= 1920
#define _CBNL_DI
#define _CBNL_DIV
#endif//_MSC_VER
#endif//_MSC_VER

/*
     :
    _CBNL_MUL        
*/
#if 1
#define _CBNL_MUL
#endif

/*
            ().
*/
#if 0
#undef  _CBNL_MUL
#endif

/* --------------------------------------------------------------
        .
    _addCBNL    (l1,l2,*p)     
    _adcCBNL  (c,l1,l2,*p)   c ,  
    _subCBNL    (l1,l2,*p)     
    _sbbCBNL  (c,l1,l2,*p)    ,  
    _muldCBNL   (l1,l2,*p)         *p,ret
    _umuldCBNL  (l1,l2,*p)        *p,ret
    _ushldCBNL  (ll,lh,sh)        ()
    _ushrdCBNL  (ll,lh,sh)       ()
    _ushld1CBNL (ll,lh)           
    _ushrd1CBNL (ll,lh)           
    _ushlCBNL   (l,sh)          (  )
    _ushrCBNL   (l,sh)         (  )
    _btCBNL     (num,sh)        
    _ulzcntCBNL (num)          
    _ubsfCBNL   (*p,num)        (Visual C++)
    _ubsrCBNL   (*p,num)        (Visual C++)
-------------------------------------------------------------- */

#ifdef  _CBNL_MI

#include <intrin.h>

/*
      /.
*/
#ifdef  _CBNL_CBI

#if     _CBNL_MI == 32
#pragma intrinsic(_addcarry_u32)
#pragma intrinsic(_subborrow_u32)
#define _addCBNL(l1,l2,p)   _addcarry_u32(0,l1,l2,(unsigned*)p)
#define _adcCBNL(c,l1,l2,p) _addcarry_u32(c,l1,l2,(unsigned*)p)
#define _subCBNL(l1,l2,p)   _subborrow_u32(0,l1,l2,(unsigned*)p)
#define _sbbCBNL(c,l1,l2,p) _subborrow_u32(c,l1,l2,(unsigned*)p)
#endif//_CBNL_MI

#if     _CBNL_MI == 64
#pragma intrinsic(_addcarry_u64)
#pragma intrinsic(_subborrow_u64)
#define _addCBNL(l1,l2,p)   _addcarry_u64(0,l1,l2,p)
#define _adcCBNL(c,l1,l2,p) _addcarry_u64(c,l1,l2,p)
#define _subCBNL(l1,l2,p)   _subborrow_u64(0,l1,l2,p)
#define _sbbCBNL(c,l1,l2,p) _subborrow_u64(c,l1,l2,p)
#endif//_CBNL_MI

#endif//_CBNL_CBI

/*
           64- .
    _CBNL_MUL       
*/
#ifdef  _CBNL_MUL
#if     _CBNL_MI == 64
#pragma intrinsic(_mul128)
#pragma intrinsic(_umul128)
#define _muldCBNL   _mul128
#define _umuldCBNL  _umul128
#endif//_CBNL_MI
#endif//_CBNL_MUL

/*
      .
*/
#ifdef  _CBNL_DI

#undef  _divdCBNL
#undef  _udivdCBNL
#undef  _moddCBNL
#undef  _umoddCBNL

#if     _CBNL_MI == 32
#pragma intrinsic(_div64)
#pragma intrinsic(_udiv64)
#define _divdCBNL   _divdCBNL_c
#define _udivdCBNL  _udivdCBNL_c
#endif//_CBNL_MI

#if     _CBNL_MI == 64
#pragma intrinsic(_div128)
#pragma intrinsic(_udiv128)
#define _divdCBNL(ll,lh,l2,p)   _div128(lh,ll,l2,p)
#define _udivdCBNL(ll,lh,l2,p)  _udiv128(lh,ll,l2,p)
#endif//_CBNL_MI

#define _moddCBNL   _moddCBNL_c
#define _umoddCBNL  _umoddCBNL_c

#endif//_CBNL_DI

/*
          64- .
*/
#if     _CBNL_MI == 64
#pragma intrinsic(__shiftleft128)
#pragma intrinsic(__shiftright128)
#define _ushldCBNL(ll,lh,sh) __shiftleft128(ll,lh,(unsigned char)(sh))
#define _ushrdCBNL(ll,lh,sh) __shiftright128(ll,lh,(unsigned char)(sh))
#if 0 // Not effective
#define _ushld1CBNL(ll,lh)   __shiftleft128(ll,lh,1)
#define _ushrd1CBNL(ll,lh)   __shiftright128(ll,lh,1)
#endif
#endif//_CBNL_MI

/*
       .
*/
#if     _CBNL_MI == 32
#if 0 // Not effective
#pragma intrinsic(_bittest)
#define _btCBNL(num,sh)    _bittest(&(num),sh)
#endif
#pragma intrinsic(_BitScanForward)
#pragma intrinsic(_BitScanReverse)
#define _ubsfCBNL _BitScanForward
#define _ubsrCBNL _BitScanReverse
#endif//_CBNL_MI

#if     _CBNL_MI == 64
#if 0 // Not effective
#pragma intrinsic(_bittest64)
#define _btCBNL(num,sh)    _bittest64(&(num),sh)
#endif
#pragma intrinsic(_BitScanForward64)
#pragma intrinsic(_BitScanReverse64)
#define _ubsfCBNL _BitScanForward64
#define _ubsrCBNL _BitScanReverse64
#endif//_CBNL_MI

/*
    Intel Haswell+ & AMD Excavator+
*/
#ifdef  __AVX2__

#if     _CBNL_MI == 32
#pragma intrinsic(__lzcnt)
#define _ulzcntCBNL __lzcnt
#endif//_CBNL_MI

#if     _CBNL_MI == 64
#pragma intrinsic(__lzcnt64)
#define _ulzcntCBNL __lzcnt64
#endif//_CBNL_MI

#endif//__AVX2__

#endif//_CBNL_MI

#if 0 //  
#undef  _muldCBNL
#undef  _umuldCBNL
#endif

#if 0 //  
#undef  _divdCBNL
#undef  _udivdCBNL
#undef  _moddCBNL
#undef  _umoddCBNL
#endif

//================================================
//         .
//================================================

#ifdef  __cplusplus
extern "C" {
#endif//__cplusplus

//             
//       Cbignumf.inl ().   _CBNL_MUL,
//          Cbignumf.inl.

#ifndef _CBNL_MUL

#define _muldCBNL   _muldCBNL_c
#define _umuldCBNL  _umuldCBNL_c

CBNL   _CBNL_C  _muldCBNL_c  (CBNL, CBNL, CBNL*);
unsigned
CBNL   _CBNL_C  _umuldCBNL_c (unsigned CBNL, unsigned CBNL, unsigned CBNL*);

#endif//_CBNL_MUL

//            
//          Cbignumf.inl (  ).

#ifndef _CBNL_DIV
/*
#define _divdCBNL   _divdCBNL_c
#define _udivdCBNL  _udivdCBNL_c
#define _moddCBNL   _moddCBNL_c
#define _umoddCBNL  _umoddCBNL_c

CBNL   _CBNL_C  _divdCBNL_c  (CBNL, CBNL, CBNL, CBNL*);
unsigned
CBNL   _CBNL_C  _udivdCBNL_c (unsigned CBNL, unsigned CBNL, unsigned CBNL,
                                                            unsigned CBNL*);
CBNL   _CBNL_C  _moddCBNL_c  (CBNL, CBNL, CBNL);
unsigned
CBNL   _CBNL_C  _umoddCBNL_c (unsigned CBNL, unsigned CBNL, unsigned CBNL);
*/
#endif//_CBNL_DIV

//           Long  CBNL, .. 
//         32-  .

//         .

int    _CBNL_C  cLongBits       (CBNL);         //  .
int    _CBNL_C  cULongBits      (unsigned CBNL);
int    _CBNL_C  cLongExBits     (CBNL);         //  0-.
int    _CBNL_C  cLongExactLog2  (CBNL);         // Log2  2**n.

//        .

unsigned
CBNL   _CBNL_C  cLongRandom (unsigned long (*pfnRand)());

#ifdef  __cplusplus
}
#endif/*__cplusplus*/

#ifndef CBNL_LONG_LONG
inline unsigned
CBNL  _CBNL_C   cLongRandom (unsigned long (*pfnRand)())
{
  return (unsigned CBNL)(*pfnRand)();
}
#endif//CBNL_LONG_LONG

//         CBNL   .

inline unsigned
CBNL   _CBNL_C  cULongMul (                     //  p = p1 * p2.
                unsigned CBNL   l1,             //  .
                unsigned CBNL   l2,             //  .
                unsigned CBNL   p [2]           //  .
        )                                       //   
{                                               // .
#ifdef  _umuldCBNL
  return (p [0] = _umuldCBNL (l1, l2, p + 1));  //   _umuldCBNL.
#else //_umuldCBNL
#ifdef  _CBNL_CBNL
  *(unsigned _CBNL_CBNL *)p = (unsigned _CBNL_CBNL)l1 * l2;
#else //_CBNL_CBNL
  p [0] = (l1 & (((CBNL)1 << (CHAR_BIT * sizeof (CBNL) / 2)) - 1)) *
          (l2 & (((CBNL)1 << (CHAR_BIT * sizeof (CBNL) / 2)) - 1));
  p [1] = (l1 >> (CHAR_BIT * sizeof (CBNL) / 2)) *
          (l2 >> (CHAR_BIT * sizeof (CBNL) / 2));
  unsigned CBNL lh = p [1];
  unsigned CBNL lmac = *(CBNL*)((unsigned char *)p + sizeof (CBNL) / 2);
  unsigned CBNL lm = lmac;
  lmac += (l1 & (((CBNL)1 << (CHAR_BIT * sizeof (CBNL) / 2)) - 1)) *
          (l2 >> (CHAR_BIT * sizeof (CBNL) / 2));
  lh += (lmac < lm ? (CBNL)1 << ((CHAR_BIT * sizeof (CBNL) / 2)) : 0);
  lm = lmac;
  lmac += (l2 & (((CBNL)1 << (CHAR_BIT * sizeof (CBNL) / 2)) - 1)) *
          (l1 >> (CHAR_BIT * sizeof (CBNL) / 2));
  lh += (lmac < lm ? (CBNL)1 << ((CHAR_BIT * sizeof (CBNL) / 2)) : 0);
  p [1] = lh;
  *(CBNL*)((unsigned char *)p + sizeof (CBNL) / 2) = lmac;
#endif//_CBNL_CBNL
  return p [0];
#endif//_umuldCBNL
}

//        CBNL   .

inline
CBNL   _CBNL_C  cLongMul (                      //  p = p1 * p2.
                        CBNL    l1,             // .
                        CBNL    l2,             // .
                        CBNL    p [2]           // .
        )                                       //   
{                                               // .
#ifdef  _muldCBNL
  return (p [0] = _muldCBNL (l1, l2, p + 1));   //   _muldCBNL.
#else //_muldCBNL
  if (l2 < 0) { l1 = -l1; l2 = -l2; }           //   .
  if (l1 >= 0)
    return cULongMul (l1, l2, (unsigned CBNL *)p);
  else {
    CBNL l = cULongMul (-l1, l2, (unsigned CBNL *)p);
    p [1] = ~p [1] + ((p[0] = l = -l) == 0);    //   .
    return l;
  }
#endif//_muldCBNL
}

//================================================
//         
//          
//        .
//================================================

//         CBNL   .

#ifdef  _CBNL_MUL

#ifndef _muldCBNL
#define _muldCBNL   _muldCBNL_i
inline
CBNL   _CBNL_C  _muldCBNL_i (                   //  l1 * l2.
                        CBNL    l1,             // .
                        CBNL    l2,             // .
                        CBNL    *p              //   .
        )                                       //   .
{
  CBNL pp [2];
  CBNL l = cLongMul (l1, l2, pp); *p = pp [1];
  return l;
}
#endif

//          CBNL   .

#ifndef _umuldCBNL
#define _umuldCBNL  _umuldCBNL_i
inline unsigned
CBNL   _CBNL_C  _umuldCBNL_i (                  //  l1 * l2.
                unsigned CBNL   l1,             //  .
                unsigned CBNL   l2,             //  .
                unsigned CBNL   *p              //   .
        )                                       //   .
{
  unsigned CBNL pp [2];
  unsigned CBNL l = cULongMul (l1, l2, pp); *p = pp [1];
  return l;
}
#endif

#endif//_CBNL_MUL

//             
//       Microsoft Visual C++.

#ifdef  _CBNL_DI

#if     _CBNL_MI == 32
inline
CBNL   _CBNL_C  _divdCBNL_c  (CBNL ll, CBNL lh, CBNL l2, CBNL *p)
{
  return _div64 (((__int64)lh<<32) + ll, l2, (int *)p);
}
inline
unsigned
CBNL   _CBNL_C  _udivdCBNL_c (unsigned CBNL ll, unsigned CBNL lh,
                              unsigned CBNL l2, unsigned CBNL *p)
{
  return _udiv64 (((__int64)lh<<32) + ll, l2, (unsigned int *)p);
}
inline
CBNL   _CBNL_C  _moddCBNL_c  (CBNL ll, CBNL lh, CBNL l2)
{
  int p; _div64 (((__int64)lh<<32) + ll, l2, &p); return p;
}
inline
unsigned
CBNL   _CBNL_C  _umoddCBNL_c (unsigned CBNL ll, unsigned CBNL lh,
                              unsigned CBNL l2)
{
  unsigned p; _udiv64 (((__int64)lh<<32) + ll, l2, &p); return p;
}
#endif//_CBNL_MI

#if     _CBNL_MI == 64
inline
CBNL   _CBNL_C  _moddCBNL_c  (CBNL ll, CBNL lh, CBNL l2)
{
  CBNL p; _div128 (lh, ll, l2, &p); return p;
}
inline
unsigned
CBNL   _CBNL_C  _umoddCBNL_c (unsigned CBNL ll, unsigned CBNL lh,
                              unsigned CBNL l2)
{
  unsigned CBNL p; _udiv128 (lh, ll, l2, &p); return p;
}
#endif//_CBNL_MI

#endif//_CBNL_DI

//         /,    .

#ifndef _addCBNL
inline
unsigned char _addCBNL  (unsigned CBNL l1, unsigned CBNL l2, unsigned CBNL *p)
{
  return ((*p = l1 + l2) < l1);
}
#endif

#ifndef _adcCBNL
inline
unsigned char _adcCBNL (unsigned char c,
                        unsigned CBNL l1, unsigned CBNL l2, unsigned CBNL *p)
{
  *p = l1 + l2 + c; return (*p < l1 || *p == l1 && c != 0);
}
#endif

#ifndef _subCBNL
inline
unsigned char _subCBNL (unsigned CBNL l1, unsigned CBNL l2, unsigned CBNL *p)
{
  return ((*p = l1 - l2) > l1);
}
#endif

#ifndef _sbbCBNL
inline
unsigned char _sbbCBNL (unsigned char c,
                        unsigned CBNL l1, unsigned CBNL l2, unsigned CBNL *p)
{
  *p = l1 - l2 - c; return (*p > l1 || *p == l1 && c != 0);
}
#endif

#ifndef _ushldCBNL
inline
unsigned CBNL _ushldCBNL (unsigned CBNL ll, unsigned CBNL lh, unsigned CBNC sh)
{
#if 0
  assert (~0U % (CHAR_BIT * sizeof (CBNL)) == CHAR_BIT * sizeof (CBNL) - 1);
  return ((lh << sh) + (ll >> ((~sh) & (CHAR_BIT * sizeof (CBNL) - 1)) >> 1));
#else
  assert (sh < CHAR_BIT * sizeof (CBNL));
  return ((lh << sh) + (ll >> (CHAR_BIT * sizeof (CBNL) - 1 - sh) >> 1));
#endif
}
#endif

#ifndef _ushrdCBNL
inline
unsigned CBNL _ushrdCBNL (unsigned CBNL ll, unsigned CBNL lh, unsigned CBNC sh)
{
#if 0
  assert (~0U % (CHAR_BIT * sizeof (CBNL)) == CHAR_BIT * sizeof (CBNL) - 1);
  return ((ll >> sh) + (lh << ((~sh) && (CHAR_BIT * sizeof (CBNL) - 1)) << 1));
#else
  assert (sh < CHAR_BIT * sizeof (CBNL));
  return ((ll >> sh) + (lh << (CHAR_BIT * sizeof (CBNL) - 1 - sh) << 1));
#endif
}
#endif

#ifndef _ushld1CBNL
inline
unsigned CBNL _ushld1CBNL (unsigned CBNL ll, unsigned CBNL lh)
{
  return ((lh << 1) + (ll >> (CHAR_BIT * sizeof (CBNL) - 1)));
}
#endif

#ifndef _ushrd1CBNL
inline
unsigned CBNL _ushrd1CBNL (unsigned CBNL ll, unsigned CBNL lh)
{
  return ((ll >> 1) + (lh << (CHAR_BIT * sizeof (CBNL) - 1)));
}
#endif

#ifndef _ushlCBNL
#define _ushlCBNL(l,sh)  ((unsigned CBNL)(l) << (unsigned CBNC)(sh))
#endif

#ifndef _ushrCBNL
#define _ushrCBNL(l,sh)  ((unsigned CBNL)(l) >> (unsigned CBNC)(sh))
#endif

#ifndef _btCBNL
inline
unsigned char _btCBNL (unsigned CBNL num, unsigned CBNC sh)
{
  return ((num & ((CBNL)1 << sh)) != 0);
}
#endif

#ifndef _ulzcntCBNL
inline
unsigned CBNL _ulzcntCBNL (unsigned CBNL num)
{
#ifdef  _ubsrCBNL
  unsigned long n;
  return (CHAR_BIT * sizeof (CBNL) - 1 - (_ubsrCBNL (&n, num)? (int)n: -1));
#else
  return (CHAR_BIT * sizeof (CBNL) - cULongBits(num));
#endif
}
#endif

#endif//_CBNL_H
